#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "classes.h"

void LIDL::info()
{
	int x,y;
	printf("Welcome to lidl v0.1.3, a wumpus clone\nBy Patrik Nilsson & Oskar Andreasson\n\n");
	for (x=0;x<=maxx;x=x+1)
	{
		for (y=0;y<=maxy;y=y+1)
		{
			room[x][y] = EMPTY;
		}
	}
	
#ifdef DEBUG
	for (x=0;x<=maxx;x=x+1)
	{
		for (y=0;y<=maxy;y=y+1)
		{
			printf("room[%i][%i] = %i ", x, y, room[x][y]);
		}
		printf("\n");
  }
#endif

  //#define RAND_MAX 20
  srand(time(NULL));
	x=1+(int) (5.0*rand()/(RAND_MAX+1.0));
	y=1+(int) (5.0*rand()/(RAND_MAX+1.0));
  room[x][y] = MONSTER;//The monster lidl
#ifdef DEBUG
	printf("Monster placed in room[%i][%i] = %i\n", x, y, room[x][y]);
#endif
  
	
#ifdef DEBUG
	for (x=0;x<=maxx;x=x+1)
	{
		for (y=0;y<=maxy;y=y+1)
		{
			printf("room[%i][%i] = %i ", x, y, room[x][y]);
		}
		printf("\n");
  }
#endif

//holes
  
  int sluta=0;
  while(sluta!=3)
  {
     x=1+(int) (5.0*rand()/(RAND_MAX+1.0));
     y=1+(int) (5.0*rand()/(RAND_MAX+1.0));
     if (room[x][y]==0)
     {
        room[x][y]=TRAP;
#ifdef DEBUG
	printf("Hole placed in room[%i][%i] = %i\n", x, y, room[x][y]);
#endif
        sluta++;
     }  
  }
  shots=5;
  
#ifdef DEBUG
  for (x=0;x<=maxx;x=x+1)
  {
     for (y=0;y<=maxy;y=y+1)
     {
        printf("room[%i][%i] = %i ", x, y, room[x][y]);
     }
     printf("\n");
  }
#endif
  
  //Bats
  sluta=0;
  while(sluta!=3)
  {
     x=1+(int) (5.0*rand()/(RAND_MAX+1.0));
     y=1+(int) (5.0*rand()/(RAND_MAX+1.0));
     if (room[x][y]==0)
     {
        room[x][y]=BAT;
#ifdef DEBUG
	printf("Bat placed in room[%i][%i] = %i\n", x, y, room[x][y]);
#endif
        sluta++;
     }  
  }
  
  //Start poss
  sluta=0;
  while (!sluta>=1)
  {
     x=1+(int) (5.0*rand()/(RAND_MAX+1.0));
     y=1+(int) (5.0*rand()/(RAND_MAX+1.0));
     //printf("room[%i] = %i\n",y, room[y]);
     if (room[x][y]==0)
     {
      //room[x][y]=4;
      wherex=x;
      wherey=y;
      sluta++;
    }
  }
	
#ifdef DEBUG
  printf ("Start location room[%i][%i].\n", wherex, wherey);
  for (x=0;x<=maxx;x=x+1)
  {
     for (y=0;y<=maxy;y=y+1)
     {
        printf("room[%i][%i] = %i ", x, y, room[x][y]);
     }
  printf("\n");
  }
#endif
};

LIDL::LIDL()
{
#ifdef DEBUG
   printf("LIDL::LIDL the lidl constructor\n");
#endif
   points=0;
   done=0;
   maxx=5;
   maxy=5;
}

void LIDL::ending()
{
#ifdef DEBUG
  printf("Entering ending()\n");
#endif
  // This ending is only shown when the user die's or win's not leaves
  if (done==TRUE)
  {
     //printf("Your ending score was:%i\n");
  }
}
