#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <termios.h>
#include <unistd.h>
#include "classes.h"

void LIDL::menu()
{
  printf("You are in room %i,%i and you have %i arrows left.\nh=Help m=Move s=Shoot q=Quit\nCommand:",wherex,wherey,shots);
  while ((choose=getchar())!=10)
    {
      switch(choose)
	{
	case 104: { help(); break; };//h
	case 109: { move(); killed(); surroundings(); break; };//m
	case 115: { shoot(); break; };//s
	case 113: { quiting(); break; };//q
	default: { printf("Sorry unknown commmand %c\n", choose); break; };
	}	
      if (choose!=104)
	if (choose!=115)
	  break;
  }
  
#ifdef DEBUG
	printf("Choose:%i\n",choose);
#endif
};

void LIDL::help()
{
  printf("\nThe goal of this game is to kill the evil Lidl monster.\n");
  printf("Move around the map by using 'm' and the direction to move in.\n");
  printf("Shoot into the room where you believe the Lidl monster is by \nentering 's' and the direction to shoot.\n");
  printf("Good luck!\n\n");
};

int LIDL::show_done()
{
  return done;
};

int LIDL::show_quit()
{
   return quit;
}

void LIDL::quiting()
{
   int yn;
   printf("Are you sure? (y/n):");
   choose=getchar(); //simpel whay to clean it up and it works :)
   while ((choose=getchar())!=10)
   {
      switch(choose)
      {
         case 'y': { quit=1; break; };
	 case 'n': { break; }
	 default: { printf("Sorry unknown commmand %c\n", choose); break; };
      }
   }
#ifdef DEBUG
   printf("yn: %i\n", yn);
#endif
}

//--Main
int main()
{
  LIDL lidl;
  lidl.info();
#ifdef DEBUG
  sleep (2);
#endif  
	lidl.surroundings();
  while (lidl.show_done()!=1&&lidl.show_quit()!=1)
	{
	  //The game
	  lidl.menu();
	}
	lidl.ending();
	return 0;
};
